Bug 606830

Summary: ld: dynamic STT_GNU_IFUNC symbol `strcmp' with pointer equality can not be used when making an executable; recompile with -fPIE and relink with -pie
Product: [Fedora] Fedora Reporter: Victor Leschuk <victor.leschuk>
Component: binutilsAssignee: Nick Clifton <nickc>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: high Docs Contact:
Priority: low    
Version: 13CC: astarta, dvlasenk, jakub, jan.kratochvil, nickc, tomash.brechko, victor.leschuk
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 785399 (view as bug list) Environment:
Last Closed: 2011-06-27 14:44:40 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Victor Leschuk 2010-06-22 11:09:16 EDT
Description of problem:

static linkage doesn't work with binutils 2.6.20

Version-Release number of selected component (if applicable):

binutils-2.20.51.0.2-20.fc13.x86_64

How reproducible:

Create a sample file and try to compile it with -static and -Wl,--export-dynamic flags.

Steps to Reproduce:
1. Create a file with the following contents: 

int main(int argc, char **argv)
{
	return 0;
}

2. Run the following command:

gcc -static -Wl,--export-dynamic test.c

  
Actual results:

/usr/bin/ld: dynamic STT_GNU_IFUNC symbol `strcmp' with pointer equality in `/usr/lib/gcc/x86_64-redhat-linux/4.4.4/../../../../lib64/libc.a(strcmp.o)' can not be used when making an executable; recompile with -fPIE and relink with -pie
collect2: ld returned 1 exit status

Expected results:

File compiles and links normally.

Additional info:

Reproduced both with Fedora 13 x86 and Fedora 13 x86_64. Reproduced when using gcc and gcc34 compilers. 

Here is the similar problem for Debian:  http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=584607

Same scenario works fine on Debian lenny x86:

$ gcc --version
gcc (Debian 4.3.2-1.1) 4.3.2
$ /lib/libc.so.6 
GNU C Library stable release version 2.7, by Roland McGrath et al.
$ dpkg-query -W binutils
binutils	2.18.1~cvs20080103-7
Comment 1 Victor Leschuk 2010-06-22 13:16:50 EDT
Works fine on Arch Linux x86_64 with the following:

$ pacman -Q gcc glibc binutils
gcc 4.5.0-6
glibc 2.12-2
binutils 2.20.1-3
Comment 2 Andreas Schwab 2010-06-23 03:41:36 EDT
--export-dynamic doesn't make sense in a static link.
Comment 3 Tomash Brechko 2011-02-09 11:57:44 EST
FIY, the reason why strcmp is dynamic is described in http://udrepper.livejournal.com/20948.html section "Automatic use of optimized function".
Comment 4 Bug Zapper 2011-06-01 11:54:39 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2011-06-27 14:44:40 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.